package com.siit.wfw.frame.utils;

import java.security.Security;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import javax.crypto.Cipher;
import javax.crypto.spec.IvParameterSpec;
import javax.crypto.spec.SecretKeySpec;
import org.bouncycastle.jce.provider.BouncyCastleProvider;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import sun.misc.BASE64Decoder;
import sun.misc.BASE64Encoder;

public class SM4Util {

   private static final Logger log = LoggerFactory.getLogger(SM4Util.class);
   private static final String Key = "SIITIMSSCSM4KEYS";
   private static final String Iv = "SIITIMSSCSM4KEYS";


   public static String encrypt(String data) {
      try {
         byte[] e = "SIITIMSSCSM4KEYS".getBytes();
         byte[] iv = "SIITIMSSCSM4KEYS".getBytes();
         byte[] dataBytes = data.getBytes();
         byte[] encryptedData = encrypt(e, iv, dataBytes);
         String cipherText = (new BASE64Encoder()).encode(encryptedData);
         if(cipherText != null && cipherText.trim().length() > 0) {
            Pattern p = Pattern.compile("\\s*|\t|\r|\n");
            Matcher m = p.matcher(cipherText);
            cipherText = m.replaceAll("");
         }

         return cipherText;
      } catch (Exception var8) {
         log.warn("[" + data + "]加密失败" + var8.getMessage());
         return null;
      }
   }

   public static String decrypt(String encryptedData) {
      try {
         byte[] e = "SIITIMSSCSM4KEYS".getBytes();
         byte[] iv = "SIITIMSSCSM4KEYS".getBytes();
         byte[] encryptedDataBytes = (new BASE64Decoder()).decodeBuffer(encryptedData);
         byte[] decryptedData = decrypt(e, iv, encryptedDataBytes);
         return new String(decryptedData);
      } catch (Exception var5) {
         log.warn("[" + encryptedData + "]解密失败" + var5.getMessage());
         return null;
      }
   }

   private static byte[] decrypt(byte[] key, byte[] iv, byte[] encryptedData) throws Exception {
      SecretKeySpec sm4Key = new SecretKeySpec(key, "SM4");
      IvParameterSpec ivSpec = new IvParameterSpec(iv);
      Cipher cipher = Cipher.getInstance("SM4/CBC/PKCS5Padding", "BC");
      cipher.init(2, sm4Key, ivSpec);
      return cipher.doFinal(encryptedData);
   }

   private static byte[] encrypt(byte[] key, byte[] iv, byte[] data) throws Exception {
      SecretKeySpec sm4Key = new SecretKeySpec(key, "SM4");
      IvParameterSpec ivSpec = new IvParameterSpec(iv);
      Cipher cipher = Cipher.getInstance("SM4/CBC/PKCS5Padding", "BC");
      cipher.init(1, sm4Key, ivSpec);
      return cipher.doFinal(data);
   }

   public static void main(String[] args) {
      String data = "sa123456";

      try {
         String e = encrypt(data);
         System.out.println("加密后数据：" + e);
         String decryptedData = decrypt(e);
         System.out.println("解密后数据：" + decryptedData);
      } catch (Exception var4) {
         var4.printStackTrace();
      }

   }

   static {
      Security.addProvider(new BouncyCastleProvider());
   }
}
